use crate::error::CustomError;

use super::renderer_integration::RendererIntegration;
use duster::renderer::DustRenderer;
use serde::Serialize;

pub(crate) struct DusterRenderer {}

impl DusterRenderer {
    pub(crate) fn new() -> DusterRenderer {
        DusterRenderer {}
    }
}

impl RendererIntegration for DusterRenderer {
    fn load_template<N, C>(&mut self, name: N, contents: C) -> Result<(), CustomError>
    where
        N: Into<String>,
        C: AsRef<str>,
    {
        let compiled_template = duster::renderer::compile_template(contents.as_ref())?;
        Ok(())
    }

    fn render<C>(&self, context: C) -> Result<String, CustomError>
    where
        C: Serialize,
    {
        let mut dust_renderer = DustRenderer::new();
        println!("{}", serde_json::to_string(&context)?);

        // TODO
        Ok("".to_owned())
    }
}
